package dsnserver;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**********************************************
 * It is for parsing the answers of a coninfo 
 * request. It stores the connections in the
 * table dsnconinfo.
 *  
 * @author kaltt
 *
 **********************************************/
public class CmdParserConinfo implements CmdParser{

	private String SourceAddr;
	int numcon;
	int numconcount;
	
	public CmdParserConinfo() {
		super();
		// TODO Auto-generated constructor stub
	}

	/**********************************************
	 * It is responsible for the lines which start
	 * with ":T" or ":TE" and stores the values to
	 * the table dsnconifo 
	 *  
	 * @author kaltt
	 *
	 **********************************************/
	public void parseLine(String line){
		@SuppressWarnings("unused") int num = 0;
		line = line.replaceAll("'","''");
		String[] token = line.split(" ");
		
		if (token[0].equals(":T") && token.length==3 && token[1].contains(":")){
			Pattern p_SL = Pattern.compile(":T [A-Fa-f0-9]{2}:[A-Fa-f0-9]{2}:[A-Fa-f0-9]{2}:[A-Fa-f0-9]{2}:[A-Fa-f0-9]{2}:[A-Fa-f0-9]{2} [0-9]+");
			Matcher m_SL = p_SL.matcher(line.trim());
			if (m_SL.matches()){
				if (token[1].length()<=5) {SourceAddr = CmdParserGetAddr.DSNpreAddr + token[1];SourceAddr = SourceAddr.trim();} 
				else {SourceAddr = token[1].trim();}
				numcon = Integer.parseInt(token[2].trim());
				Parser.setParserState(this);
			}
		}
		else if (Parser.getParserState() == this && token[0].equals(":TE")){
			Pattern p_SL = Pattern.compile(":TE [A-Fa-f0-9]{2}:[A-Fa-f0-9]{2} [0-9]+ .[0-9]+");
			Matcher m_SL = p_SL.matcher(line.trim());
			if (m_SL.matches()){	
				numconcount++;	
				String NeighborAddr;
				if (token[1].length()<=5) {NeighborAddr = CmdParserGetAddr.DSNpreAddr + token[1];NeighborAddr = NeighborAddr.trim();} else {NeighborAddr = token[1].trim();}
				String state = token[2];
				String rssi = token[3];
				SQLDBcommunication.lock();
				num = SQLDBcommunication.sendQueryToDB("" +
						"INSERT INTO `dsnconinfo` ( `ID` , `time` , `SourceAddr` , `NeighborAddr` , `State` , `rssi` ) " +
						"VALUES ( NULL , CURRENT_TIMESTAMP , '" + SourceAddr + "', '" + NeighborAddr + "', '" + state + "', '" + rssi + "');");
				SQLDBcommunication.unlock();
				if (numconcount >= numcon){
					numconcount = 0;
					Parser.resetParserState();	
				}
			}
			else{
				Parser.resetParserState();
			}
		}
		else {Parser.resetParserState();}
	}
		
}
