package dsnserver;

import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Hashtable;
import java.util.Vector;

/**********************************************
 * A function wich is used as a XmlRpc function.
 * It gives back rows of the dsnlog table. 
 *
 * @author kaltt
 *
 **********************************************/
public class XmlRpcGetDBEvent {

	public XmlRpcGetDBEvent() {
		super();
		// TODO Auto-generated constructor stub
	}

	/**********************************************
	* A function wich is used as a XmlRpc function.
	* It gives back all rows of the dsnlog table 
	* in the DB, which time is between time_from 
	* and time_till.
	*
	* @param String DSNID <br>
	* int levelmask (dez x01-Error x02-Warning x03-Info x04-Debug) (set all = 15, set Error & Warning = 3)<br>
	* int logclass (0 = all classes) <br>
	* String logtext (it is looking for this String in the logtext in the DB, if the String is "" it gives back all rows which correspond with the other clauses)<br> 
	* String time_from (yyyy-MM-dd HH:mm:ss)<br>
	* String time_till (yyyy-MM-dd HH:mm:ss) <br>
	* int order (
	* 	0 DBtime;
	* 	1 DSNID;
	* 	2 MsgID,DSNID;
	* 	3 DSNtime,DSNID;
	* 	4 time,DSNtime;
	* 	5 class,DBtime;
	* 	6 Level,DBtime;
	* 	7 LogText,DBtime,DSNID;) <br>
	* String ascdesc (asc = ascending, desc = descending) <br>
	* int start (it gives back the entries after this row) <br>
	* int maxReply (maxReply = 0 is to get all back) <br>
	* 
	* @return Hashtable result (Keys: DSNID, 
	* DSNtime, time, Level, DBtime, LogText)
	* 
	**********************************************/
	public Vector getDBEvent(String DSNID, int levelmask, int logclass, String logtext, String time_from, String time_till, int order, String ascdesc, int start, int maxReply){
		
		Vector<Hashtable> result = new Vector<Hashtable>();
		Hashtable<String,Object> t;
		boolean doitagain = true;
		int count = 0;

		String level = "";
        switch (levelmask) {
	        case 0:   level = ""; break;
	        case 1:   level = " AND Level = 1 "; break;
	        case 2:   level = " AND Level = 2 "; break;
	        case 3:   level = " AND ( Level = 1 OR Level = 2 ) "; break;
	        case 4:   level = " AND Level = 3 "; break;
	        case 5:   level = " AND ( Level = 1 OR Level = 3 )"; break;
	        case 6:   level = " AND ( Level = 2 OR Level = 3 )"; break;
	        case 7:   level = " AND ( Level = 1 OR Level = 2 OR Level = 3 ) "; break;
	        case 8:   level = " AND Level = 4 "; break;
	        case 9:   level = " AND ( Level = 1 OR Level = 4 ) "; break;
	        case 10:  level = " AND ( Level = 2 OR Level = 4) "; break;
	        case 11:  level = " AND ( Level = 1 OR Level = 2 OR Level = 4 ) "; break;
	        case 12:  level = " AND ( Level = 3 OR Level = 4) "; break;
	        case 13:  level = " AND ( Level = 1 OR Level = 3 OR Level = 4 ) "; break;
	        case 14:  level = " AND ( Level = 2 OR Level = 3 OR Level = 4 ) "; break;
	        case 15:  level = " AND ( Level = 1 OR Level = 2 OR Level = 3 OR Level = 4 ) "; break; 
	        case 16:  level = " AND Level = 5 "; break;
	        case 17:  level = " AND ( Level = 1 OR Level = 5 ) "; break;
	        case 18:  level = " AND ( Level = 2  OR Level = 5) "; break;
	        case 19:  level = " AND ( Level = 1 OR Level = 2 OR Level = 5 ) "; break;
	        case 20:  level = " AND ( Level = 3 OR Level = 5 ) "; break;
	        case 21:  level = " AND ( Level = 1 OR Level = 3 OR Level = 5 ) "; break;
	        case 22:  level = " AND ( Level = 2 OR Level = 3 OR Level = 5 ) "; break;
	        case 23:  level = " AND ( Level = 1 OR Level = 2 OR Level = 3 OR Level = 5 ) "; break;
	        case 24:  level = " AND ( Level = 4 OR Level = 5 ) "; break;
	        case 25:  level = " AND ( Level = 1 OR Level = 4 OR Level = 5 ) "; break;
	        case 26:  level = " AND ( Level = 2 OR Level = 4 OR Level = 5 ) "; break;
	        case 27:  level = " AND ( Level = 1 OR Level = 2 OR Level = 4 OR Level = 5 ) "; break;
	        case 28:  level = " AND ( Level = 3 OR Level = 4 OR Level = 5 ) "; break;
	        case 29:  level = " AND ( Level = 1 OR Level = 3 OR Level = 4 OR Level = 5 ) "; break;
	        case 30:  level = " AND ( Level = 2 OR Level = 3 OR Level = 4 OR Level = 5 ) "; break;
	        case 31:  level = " AND ( Level = 1 OR Level = 2 OR Level = 3 OR Level = 4 OR Level = 5 ) "; break;
	        default:  level = ""; break;
        }
        
        String logtext_sql = "";
        if (!logtext.equals("")){
        	logtext_sql = " AND `LogText` LIKE '%" + logtext +"%' ";
        }
        
        String logclass_str = "";
        if (logclass == 0) {logclass_str = "";}
        else { logclass_str = " AND Class = "+logclass+" ";}
        
        String DSNID_sql = "";
        if (!(DSNID.equals("all"))){DSNID_sql = " AND DSNID = '" + DSNID + "' ";}
		
        //String maxReply_sql = "";
        //if (maxReply!=0){maxReply_sql = "ORDER BY `ID` DESC LIMIT 0 , " + Integer.toString(maxReply);}
        
        String sql_order = "";
        if (maxReply != 0){
	        switch (order) {
	    		case 0: sql_order = " ORDER BY `DBtime` "+ascdesc.toUpperCase().toUpperCase()+" LIMIT "+Integer.toString(start)+", "+Integer.toString(maxReply);break;
	    		case 1: sql_order = " ORDER BY `DSNID` "+ascdesc.toUpperCase()+" LIMIT "+Integer.toString(start)+", "+Integer.toString(maxReply);break;
	    		case 2: sql_order = " ORDER BY `MsgID` "+ascdesc.toUpperCase()+", `DSNID` "+ascdesc.toUpperCase()+" LIMIT "+Integer.toString(start)+", "+Integer.toString(maxReply);break;
	    		case 3: sql_order = " ORDER BY `DSNtime` "+ascdesc.toUpperCase()+", `DSNID` "+ascdesc.toUpperCase()+" LIMIT "+Integer.toString(start)+", "+Integer.toString(maxReply);break;
	    		case 4: sql_order = " ORDER BY `time` "+ascdesc.toUpperCase()+", `DSNtime` "+ascdesc.toUpperCase()+", `DSNID` "+ascdesc.toUpperCase()+" LIMIT "+Integer.toString(start)+", "+Integer.toString(maxReply);break;
	    		case 5: sql_order = " ORDER BY `Class` "+ascdesc.toUpperCase()+", `DBtime` "+ascdesc.toUpperCase()+" LIMIT "+Integer.toString(start)+", "+Integer.toString(maxReply);break;
	    		case 6: sql_order = " ORDER BY `Level` "+ascdesc.toUpperCase()+", `DBtime` "+ascdesc.toUpperCase()+" LIMIT "+Integer.toString(start)+", "+Integer.toString(maxReply);break;
	    		case 7: sql_order = " ORDER BY `LogText` "+ascdesc.toUpperCase()+", `DBtime` "+ascdesc.toUpperCase()+", `DSNID` "+ascdesc.toUpperCase()+" LIMIT "+Integer.toString(start)+", "+Integer.toString(maxReply);break;
	        	default: sql_order = "";break;
	       }
        }
        else {
	        switch (order) {
	    		case 0: sql_order = " ORDER BY `DBtime` "+ascdesc.toUpperCase();break;
	    		case 1: sql_order = " ORDER BY `DSNID` "+ascdesc.toUpperCase();break;
	    		case 2: sql_order = " ORDER BY `MsgID` "+ascdesc.toUpperCase()+", `DSNID` "+ascdesc.toUpperCase();break;
	    		case 3: sql_order = " ORDER BY `DSNtime` "+ascdesc.toUpperCase()+", `DSNID` "+ascdesc.toUpperCase();break;
	    		case 4: sql_order = " ORDER BY `time` "+ascdesc.toUpperCase()+", `DSNtime` "+ascdesc.toUpperCase();break;
	    		case 5: sql_order = " ORDER BY `Class` "+ascdesc.toUpperCase()+", `DBtime` "+ascdesc.toUpperCase();break;
	    		case 6: sql_order = " ORDER BY `Level` "+ascdesc.toUpperCase()+", `DBtime` "+ascdesc.toUpperCase();break;
	    		case 7: sql_order = " ORDER BY `LogText` "+ascdesc.toUpperCase()+", `DBtime` "+ascdesc.toUpperCase();break;
	        	default: sql_order = "";break;  
	        }
        }
                
        while (doitagain && count < 10){
			result.clear();
			SQLDBcommunication.lock();
			ResultSet result_sql = SQLDBcommunication.getResultsFromDB("" +
					"SELECT * FROM `dsnlog`" +
					"WHERE DBtime >= '" + time_from + "'" +
					"AND DBtime <= '" + time_till + "'" +
					level + logclass_str + logtext_sql + 
					DSNID_sql + sql_order + ";");
			if (result_sql != null){
				try {
					while (result_sql.next()) 
					{  
						t = new Hashtable<String,Object>();
						//t.clear();
						t.put("DSNID", new String(result_sql.getString("DSNID")));
						t.put("MsgID", new String(result_sql.getString("MsgID")));
						t.put("DSNtime", new String(result_sql.getString("DSNtime")));
						t.put("time", new String(result_sql.getString("time")));
						t.put("Class", new String(result_sql.getString("Class")));
						t.put("Level", new String(result_sql.getString("Level")));
						t.put("DBtime", new String(result_sql.getString("DBtime")));
						t.put("LogText", new String(result_sql.getString("LogText")));
						result.add(t);
					}
					if (!result_sql.next()){doitagain = false;}	
				}
				catch (NullPointerException e){
					try {
						RXTXComm.writeLog("< " + e.toString());
					} catch (IOException e1) {}
					doitagain = true;
					count++;
				} 
				catch (SQLException e) {
					try {
						RXTXComm.writeLog("< " + e.toString());
					} catch (IOException e1) {}
					doitagain = true;
					count++;
				}
				catch (Exception e){
					try {
						RXTXComm.writeLog("< " + e.toString());
					} catch (IOException e1) {}
					doitagain = false;	
				}

			}
			SQLDBcommunication.unlock();
		}
		return result;
	}
	
	/**********************************************
	* result = getDBEvent(DSNID,  levelmask, logclass, logtext, time_from, time_till, 0);
	*
	* @param String DSNID <br>
	* int levelmask (dez x01-Error x02-Warning x03-Info x04-Debug) (set all = 15, set Error & Warning = 3)<br>
	* int logclass (0 = all classes) <br>
	* String logtext (it is looking for this String in the logtext in the DB, if the String is "" it gives back all rows which corrospond with the other clauses)<br> 
	* String time_from (yyyy-MM-dd HH:mm:ss)<br>
	* String time_till (yyyy-MM-dd HH:mm:ss) <br>
	* 
	* 
	* @return Hashtable result (Keys: DSNID, 
	* DSNtime, time, Level, DBtime, LogText)
	* 
	**********************************************/
	@SuppressWarnings("unchecked")
	public Vector getDBEvent(String DSNID, int levelmask, int logclass, String logtext, String time_from, String time_till) {
		Vector<Hashtable> result = new Vector<Hashtable>();
		result = getDBEvent(DSNID,  levelmask, logclass, logtext, time_from, time_till, 0, "asc", 0, 0);
		return result;
	}
}