package dsnserver;

import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import org.apache.xmlrpc.AuthenticatedXmlRpcHandler;
import org.apache.xmlrpc.WebServer;

/**********************************************
 * A function wich is used as a XmlRpc function.
 * It is used for setting the location string 
 * on the BTnode. 
 *
 * @author kaltt
 * 
 **********************************************/
public class XmlRpcSetDSNLocation implements AuthenticatedXmlRpcHandler{

	Communication myComm;
	WebServer server;
	
	public XmlRpcSetDSNLocation(Communication comm,WebServer server) {
		this.server = server;
		myComm = comm;
	}

	/**********************************************
	 * A function wich is used as a XmlRpc function.
	 * It is used for setting the location string 
	 * on the BTnode. 
	 *
	 * @param String DSNID, String location
	 * 
	 * @return "OK!"
	 *
	 **********************************************/
	public String setDSNLocation(String DSNID, String location) throws Exception{
	    
		myComm.lock();
		myComm.writeLine("rpc " + DSNID + " dsn set loc " + location);
		Thread.sleep(500);
		myComm.writeLine("rpc " + DSNID + " dsn get loc");
		myComm.unlock();
		
		return "OK!";
	}
	
			
	public Object execute(String method, Vector v, String user,  String password) {
		if(checkPassword(user, password)){
			return execute(method, v);
		}
		else{
			try {
				RXTXComm.writeLog("Error in DSNLocation: Unauthorized User (user:" + user + ")");
			} catch (IOException e1) {}
			return null;
		}
	}

	protected Object execute(String method, Vector v){
		String result = null;
		if(method.endsWith(".setDSNLocation")){
			try {
				result = setDSNLocation((String)v.get(0),(String)v.get(1));
			} catch (NumberFormatException e) {
				e.printStackTrace();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return result;
	}
	
	public boolean checkPassword(String user, String password){
		boolean pwd = false;
		SQLDBcommunication.lock();
		ResultSet result = SQLDBcommunication.getResultsFromDB("" +
				"SELECT *  FROM `dsnpwd` " +
				"WHERE `name` = '" + user + "' " +
				"AND `pwd` = md5('" + password + "') " +
				"AND (`function` =  'setDSNLocation' OR `function` =  'all' )");
		try {
			if (result.next()){pwd = true;}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		SQLDBcommunication.unlock();
		if (pwd) return true;
		else return false;
	}

}
