package dsnserver;

import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import org.apache.xmlrpc.AuthenticatedXmlRpcHandler;
import org.apache.xmlrpc.WebServer;

/**********************************************
 * A function wich is used as a XmlRpc function.
 * It is used for setting the NodeInfo string 
 * in the table DSNInfo on the database. 
 *
 * @author kaltt
 * 
 **********************************************/
public class XmlRpcSetNodeInfo implements AuthenticatedXmlRpcHandler{

	Communication myComm;
	WebServer server;
	
	public XmlRpcSetNodeInfo() {}

	/**********************************************
	 * A function wich is used as a XmlRpc function.
	 * It is used for setting the NodeInfo string 
	 * in the table DSNInfo on the database. 
	 *
	 * @param String DSNID, String NodeInfo
	 * 
	 * @return int row - number of affected rows
	 *
	 **********************************************/
	public int setNodeInfo(String DSNID, String NodeInfo) throws Exception{
	    String query = "UPDATE `dsninfo` SET `NodeInfo` = '" + NodeInfo + "' WHERE `DSNID` = '" + DSNID + "';";	    
		int row = SQLDBcommunication.sendQueryToDB(query);
		return row;
	}
	
			
	public Object execute(String method, Vector v, String user,  String password) {
		if(checkPassword(user, password)){
			return execute(method, v);
		}
		else{
			try {
				RXTXComm.writeLog("Error in DSNLocation: Unauthorized User (user:" + user + ")");
			} catch (IOException e1) {}
			return null;
		}
	}

	protected Object execute(String method, Vector v){
		int result = 0;
		if(method.endsWith(".setNodeInfo")){
			try {
				result = setNodeInfo((String)v.get(0),(String)v.get(1));
			} catch (NumberFormatException e) {
				e.printStackTrace();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return result;
	}
	
	public boolean checkPassword(String user, String password){
		boolean pwd = false;
		SQLDBcommunication.lock();
		ResultSet result = SQLDBcommunication.getResultsFromDB("" +
				"SELECT *  FROM `dsnpwd` " +
				"WHERE `name` = '" + user + "' " +
				"AND `pwd` = md5('" + password + "') " +
				"AND (`function` =  'setNodeInfo' OR `function` =  'all' )");
		try {
			if (result.next()){pwd = true;}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		SQLDBcommunication.unlock();
		if (pwd) return true;
		else return false;
	}

}
