package dsnserver;

import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import org.apache.xmlrpc.AuthenticatedXmlRpcHandler;
import org.apache.xmlrpc.WebServer;

/**********************************************
 * A function which is used as a XmlRpc function.
 * It is used for sending out a target command. 
 *
 * @author kaltt
 * 
 **********************************************/
public class XmlRpcTargetCommand implements AuthenticatedXmlRpcHandler{

	Communication myComm;
	WebServer server;
	
	public XmlRpcTargetCommand(Communication comm, WebServer server) {
		this.server = server;
		myComm = comm;
	}

	/**********************************************
	* A function which is used as a XmlRpc function.
	* It is used for sending out a target command.
	* The command string have to be shorter than 90 bytes.
	*  
	* @param String DSNID<br>
	* String command (the command that will be 
	* sent to the Target, must be shorter than 110 bytes)
	* 	
	* @return return "OK!" or "too long!" 
	**********************************************/
	public  String targetCommand(String DSNID, String command) throws Exception{
		
		if (command.length()>110){return "too long!";}
		
		if (DSNID.equals("all")){DSNID = "00:00:00:00:00:00";}

		myComm.lock();
        myComm.writeLine("rpcs " + DSNID + " tcmd " + command);
		myComm.unlock();
		
		return "OK!";
	}

	public Object execute(String method, Vector v, String user,  String password) {
		if(checkPassword(user, password)){
			return execute(method, v);
		}
		else{
			try {
				RXTXComm.writeLog("Error in TargetCommand: Unauthorized User (user:" + user + ")");
			} catch (IOException e1) {}
			return null;
		}
	}

	protected Object execute(String method, Vector v){
		String result = null;
		if(method.endsWith(".targetCommand")){
			try {
				result = targetCommand((String)v.get(0),(String)v.get(1));
			} catch (NumberFormatException e) {
				e.printStackTrace();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return result;
	}
	
	public boolean checkPassword(String user, String password){
		boolean pwd = false;
		SQLDBcommunication.lock();
		ResultSet result = SQLDBcommunication.getResultsFromDB("" +
				"SELECT *  FROM `dsnpwd` " +
				"WHERE `name` = '" + user + "' " +
				"AND `pwd` = md5('" + password + "') " +
				"AND (`function` =  'targetCommand' OR `function` =  'all' )");
		try {
			if (result.next()){pwd = true;}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		SQLDBcommunication.unlock();
		if (pwd) return true;
		else return false;
	}

}
