package dsnserver;

import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import org.apache.xmlrpc.AuthenticatedXmlRpcHandler;
import org.apache.xmlrpc.WebServer;

/**********************************************
 * A function which is used as a XmlRpc function.
 * It is used for flashing a target. 
 *
 * @author kaltt
 * 
 **********************************************/
public class XmlRpcTargetFlash implements AuthenticatedXmlRpcHandler{

	Communication myComm;
	WebServer server;
	static String msg = "";
	
	public XmlRpcTargetFlash(Communication comm,WebServer server){
		this.server = server;
		myComm = comm;
	}
	
	public static void setmsg(String setmsg){
		msg = setmsg;
	}

	/**********************************************
	* A function which is used as a XmlRpc function.
	* It is used for flashing a target.
	*  
	* @param String DSNID ("all" for all nodes) <br>
	* 
	* @return String msg (it is set to the output of 
	* command tg flash if the command is not send to all
	* nodes, otherwise it gives back "unknown". After 
	* 20 seconds it gives back unknown as well.)
	**********************************************/
	public String targetFlash(String DSNID) throws Exception{
		
       if (DSNID.equals("all")){DSNID = "00:00:00:00:00:00";}

       msg = "";
       
       myComm.lock();
       myComm.writeLine("rpcs " + DSNID + " " + GetProperty.get("tgFlash"));
       myComm.unlock();
		
		long time = System.currentTimeMillis();
		long waittime = System.currentTimeMillis() + Integer.parseInt(GetProperty.get("FlashTimeout"));
		
		if (!(DSNID.equals("00:00:00:00:00:00"))){
    	   while ((msg.equals("")) && (time < waittime)){
    		   Thread.sleep(500);
    		   time = System.currentTimeMillis();
    	   }
       }
       if (msg.equals("")){ msg = "unknown";}
		
       return msg;
	}

	
	public Object execute(String method, Vector v, String user,  String password) {
		if(checkPassword(user, password)){
			return execute(method, v);
		}
		else{
			try {
				RXTXComm.writeLog("Error in DSNCommand: Unauthorized User (user:" + user + ")");
			} catch (IOException e1) {}
			return null;
		}
	}

	protected Object execute(String method, Vector v){
		String result = null;
		if(method.endsWith(".targetFlash")){
			try {
				result = targetFlash((String)v.get(0));
			} catch (NumberFormatException e) {
				e.printStackTrace();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return result;
	}
	
	public boolean checkPassword(String user, String password){
		boolean pwd = false;
		SQLDBcommunication.lock();
		ResultSet result = SQLDBcommunication.getResultsFromDB("" +
				"SELECT *  FROM `dsnpwd` " +
				"WHERE `name` = '" + user + "' " +
				"AND `pwd` = md5('" + password + "') " +
				"AND (`function` =  'targetFlash' OR `function` =  'all' )");
		try {
			if (result.next()){pwd = true;}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		SQLDBcommunication.unlock();
		if (pwd) return true;
		else return false;
	}


}
