package dsnserver;

import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Hashtable;
import java.util.Vector;

import org.apache.xmlrpc.AuthenticatedXmlRpcHandler;

/**********************************************
 * A function which is used as a XmlRpc function.
 * It is used for starting or stopping the
 * Logging Thread. 
 *
 * @author kaltt
 * 
 **********************************************/
public class XmlRpcThreadSwitch implements AuthenticatedXmlRpcHandler{

	public static Boolean LoggingSwitch 	= true; 
	public static Boolean DSNPingSwitch 	= true; 
	public static Boolean DSNVersionSwitch 	= true; 
	public static Boolean DSNLocationSwitch = true; 
	public static Boolean DSNProgInfoSwitch = true; 
	public static Boolean ConinfoSwitch 	= true; 
	public static Boolean JawsTimeSwitch 	= true; 
	
	public XmlRpcThreadSwitch() {}

	/**********************************************
	* A function which is used as a XmlRpc function.
	* It is used for starting or stopping the
	* Logging Thread.
	*  
	* @param String thread (logging | dsnping |dsnversion | 
	* dsnlocation | dsnproginfo | coninfo | jawstime)<br> 
	* String state (on | off)
	* 	
	* @return return "on" or "off" 
	**********************************************/
	public String threadSwitch(String thread, String state) throws Exception{
		if (thread.equals("logging")){
			if (state.equals("on")){LoggingSwitch = true;}
			else if (state.equals("off")){LoggingSwitch = false;}
		}
		else if (thread.equals("dsnping")){
			if (state.equals("on")){DSNPingSwitch = true;}
			else if (state.equals("off")){DSNPingSwitch = false;}
		}
		else if (thread.equals("dsnversion")){
			if (state.equals("on")){DSNVersionSwitch = true;}
			else if (state.equals("off")){DSNVersionSwitch = false;}
		}
		else if (thread.equals("dsnlocation")){
			if (state.equals("on")){DSNLocationSwitch = true;}
			else if (state.equals("off")){DSNLocationSwitch = false;}
		}
		else if (thread.equals("dsnproginfo")){
			if (state.equals("on")){DSNProgInfoSwitch = true;}
			else if (state.equals("off")){DSNProgInfoSwitch = false;}
		}
		else if (thread.equals("coninfo")){
			if (state.equals("on")){ConinfoSwitch = true;}
			else if (state.equals("off")){ConinfoSwitch = false;}
		}
		else if (thread.equals("jawstime")){
			if (state.equals("on")){JawsTimeSwitch = true;}
			else if (state.equals("off")){JawsTimeSwitch = false;}
		}
				
		return state;
	}

	public Vector get() throws Exception{
		Vector<Hashtable> result = new Vector<Hashtable>();
		Hashtable<String,Object> t;

		t = new Hashtable<String,Object>();
		if (LoggingSwitch){t.put("LoggingSwitch", new String("true"));}
		else {t.put("LoggingSwitch", new String("false"));}
		if (DSNPingSwitch){t.put("DSNPingSwitch", new String("true"));}
		else {t.put("DSNPingSwitch", new String("false"));}
		if (DSNVersionSwitch){t.put("DSNVersionSwitch", new String("true"));}
		else {t.put("DSNVersionSwitch", new String("false"));}
		if (DSNLocationSwitch){t.put("DSNLocationSwitch", new String("true"));}
		else {t.put("DSNLocationSwitch", new String("false"));}
		if (DSNProgInfoSwitch){t.put("DSNProgInfoSwitch", new String("true"));}
		else {t.put("DSNProgInfoSwitch", new String("false"));}
		if (ConinfoSwitch){t.put("ConinfoSwitch", new String("true"));}
		else {t.put("ConinfoSwitch", new String("false"));}
		if (JawsTimeSwitch){t.put("JawsTimeSwitch", new String("true"));}
		else {t.put("JawsTimeSwitch", new String("false"));}

		result.add(t);	
		
		return result;
	}
	
	public Object execute(String method, Vector v, String user,  String password) {
		if(checkPassword(user, password)){
			return execute(method, v);
		}
		else{
			try {
				RXTXComm.writeLog("Error in TargetCommand: Unauthorized User (user:" + user + ")");
			} catch (IOException e1) {}
			return null;
		}
	}

	protected Object execute(String method, Vector v){
		if(method.endsWith(".threadSwitch")){
			String result = null;
			try {
				result = threadSwitch((String)v.get(0),(String)v.get(1));
			} catch (NumberFormatException e) {
				e.printStackTrace();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return result;
		}
		if(method.endsWith(".get")){
			Vector result = null;
			try {
				result = get();
			} catch (NumberFormatException e) {
				e.printStackTrace();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return result;
		}
		return v;
	}
	
	public boolean checkPassword(String user, String password){
		boolean pwd = false;
		SQLDBcommunication.lock();
		ResultSet result = SQLDBcommunication.getResultsFromDB("" +
				"SELECT *  FROM `dsnpwd` " +
				"WHERE `name` = '" + user + "' " +
				"AND `pwd` = md5('" + password + "') " +
				"AND (`function` =  'threadSwitch' OR `function` =  'all' )");
		try {
			if (result.next()){pwd = true;}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		SQLDBcommunication.unlock();
		if (pwd) return true;
		else return false;
	}

}
