package dsnserver;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import org.apache.xmlrpc.AuthenticatedXmlRpcHandler;
import org.apache.xmlrpc.WebServer;

import com.sun.org.apache.xerces.internal.impl.dv.util.Base64;

/**********************************************
 * A function wich is used as a XmlRpc function.
 * It is for uploading a .hex file to the 
 * folder hex/. 
 *
 * @author kaltt
 *
 **********************************************/
public class XmlRpcUploadFile implements AuthenticatedXmlRpcHandler{

	WebServer server;
	
	public XmlRpcUploadFile(WebServer server){
		this.server = server;
	}

	/**********************************************
	 * A function wich is used as a XmlRpc function.
	 * It is for uploading a .hex file to the 
	 * folder hex/.
	 * 
	 * @param String filename (the name how the file
	 * should be stored in the folder hex/ (if this
	 * name already exists in the folder hex/, the file will
	 * be overwritten.))<br>
	 * String base64 (the file which you would like to
	 * upload. It has to be converted into base64.)
	 * 
	 * @return String filename (the name of the stored 
	 * file in the folder /hex)
	 *  
	 **********************************************/
	public String uploadFile(String filename, String base64) throws Exception{
		
	    if ((!(filename.endsWith(".hex")))&&(!(filename.endsWith(".ihex")))){
	    	throw new Exception("it must be a .hex file!");
	    }
//// If you don't want that a file is 
//// overwritten, you have to uncomment
//// the following lines.
//	    
//		Date now = new Date();	    
//		SimpleDateFormat df = new SimpleDateFormat( "yyMMddHHmm" );
//		String time = df.format(now);
//
//		File dir = new File(GetProperty.get("hexPath"));
//		FilenameFilter ff = new FilenameFilter() {
//			public boolean accept(File dir, String name) {
//				if (name.endsWith(".hex"))
//					return true;
//				return false;
//			}
//		};
//		String[] hexFiles = dir.list(ff);
//		if(hexFiles != null){
//			for (int i = 0; i < hexFiles.length; i++) {
//				if (filename.equals(hexFiles[i])){
//					filename = 	filename.substring(0,filename.length()-4) + "_" +time + ".hex";
//				}
//			}
//		}
		byte[] byt = Base64.decode(base64);
		File file = new File(GetProperty.get("hexPath") +"/"+ filename);
		FileOutputStream os = new FileOutputStream(file);
		os.write(byt);
		os.close();
		
		return filename;
	}

	public Object execute(String method, Vector v, String user,  String password) {
		if(checkPassword(user, password)){
			return execute(method, v);
		}
		else{
			try {
				RXTXComm.writeLog("Error in DSNCommand: Unauthorized User (user:" + user + ")");
			} catch (IOException e1) {}
			return null;
		}
	}

	protected Object execute(String method, Vector v){
		String result = null;
		if(method.endsWith(".uploadFile")){
			try {
				result = uploadFile((String)v.get(0),(String)v.get(1));
			} catch (NumberFormatException e) {
				e.printStackTrace();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return result;
	}
	
	public boolean checkPassword(String user, String password){
		boolean pwd = false;
		SQLDBcommunication.lock();
		ResultSet result = SQLDBcommunication.getResultsFromDB("" +
				"SELECT *  FROM `dsnpwd` " +
				"WHERE `name` = '" + user + "' " +
				"AND `pwd` = md5('" + password + "') " +
				"AND (`function` =  'uploadFile' OR `function` =  'all' )");
		try {
			if (result.next()){pwd = true;}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		SQLDBcommunication.unlock();
		if (pwd) return true;
		else return false;
	}


}
